/*
 * MIDTacToe: tic-tac-toe for modile phones
 * Copyright (C) 2003  Jason Pratt
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package org.jasonpratt.midtactoe;

import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

/**
 * <p>Copyright: Copyright (c) 2003</p>
 * @author Jason Pratt
 */
public class MIDTacToe extends MIDlet {
	protected int currentBoard;
	protected int currentPlayer;
	protected int userPlayer;
	protected int difficulty;
	protected TicTacToeCanvas ticTacToeCanvas;

	public Display display;

	public MIDTacToe() {
		init();
	}

	private void init() {
		display = Display.getDisplay( this );
		currentBoard = 0;
		currentPlayer = TicTacToeEngine.X_PLAYER;
		userPlayer = TicTacToeEngine.X_PLAYER;
		difficulty = 5;
		ticTacToeCanvas = new TicTacToeCanvas( this );
		display.setCurrent( ticTacToeCanvas );
		TicTacToeEngine.fillClearedCache();
	}

	public void startApp() {
		ticTacToeCanvas.haveComputerPlayIfAppropriate();
		ticTacToeCanvas.repaint();
	}

	public void pauseApp() {
		ticTacToeCanvas.interruptThinking();
	}

	public void destroyApp( boolean unconditional ) {
	}

	public void quitApp() {
		destroyApp( true );
		notifyDestroyed();
	}

	public boolean isGameOver() {
		return (TicTacToeEngine.getNumMovesLeft( currentBoard ) < 1) ||
				TicTacToeEngine.isXWin( currentBoard ) ||
				TicTacToeEngine.isOWin( currentBoard );
	}
}